Program expsmsgd;
{ This executable is Delphi7 / Turbo Pascal 7 compatible. }
{$IFDEF WIN32}
{$APPTYPE CONSOLE}
{$ENDIF}

Const
  DataStart: String[24] =
    #$B1#$90#$DF#$AB#$96#$92#$9A#$8D#$8C#$DF#$BE#$89+
    #$9E#$96#$93#$9E#$9D#$93#$9A#$F5#$FF#$FF#$FF#$FF;
  DataSize = $2000; { should be enough for all 5 executables }
  Sections: Array[0..8] Of Array[0..8] Of Char =
  ('CINEMAS',
   'END',
   'ITEMS',
   'COPYRIGHT',
   'LASTLEVEL',
   'CREDITS',
   'PASSWORDS',
   'PASSINFO',
   'EOF');

{ This is extremly SLOW, but I want TP7-compatible code,
  since both Exhumed and Powerslave are DOS based games. }
Function FindDataStart(Var F: File; Q: String): Boolean;
Var
    N, M, I, J, K: LongInt;
                D: Array[0..255] Of Byte;

Function GetChr(C: LongInt): Char;
Var Ch: Char;
Begin
  Seek(F, C - 1);
  BlockRead(F, Ch, 1);
  GetChr:=Ch;
End;

Begin
  FindDataStart:=False;
  N:=FileSize(F);
  M:=Length(Q);
  FillChar(D, 256, M);
  For I:=1 To M-1 Do D[Ord(Q[I])]:=M-I;
  I:=M;
  Repeat
    J:=M;
    K:=I;
    While ((J<>0) And (Q[J] = GetChr(K))) Do
      Begin
        K:=K-1;
        J:=J-1;
      End;
    I:=I + D[Ord(GetChr(I))]
  Until ((J = 0) Or (I>N));
  If J = 0 Then FindDataStart:=True;
End;

Var
   I, J: Integer;
   S, K: String;
   P, O: ^Byte;
     Fl: File;
Begin
  WriteLn('Exhumed / PowerSlave executable message decrypter.');
  WriteLn('(c) -=CHE@TER=- 2010');
  WriteLn('http://CTPAX-CHEATER.losthost.org');
  WriteLn;
  If ParamCount <> 1 Then
    Begin
      WriteLn('Usage: expsmsgd filename.exe');
      WriteLn;
      Exit;
    End;
  Assign(Fl, ParamStr(1));
  FileMode:=0;
  {$I-}
  Reset(Fl, 1);
  {$I+}
  FileMode:=2;
  If IOResult <> 0 Then
    Begin
      WriteLn('Can''t open file: ' + ParamStr(1));
      Exit;
    End;
  { Some kind of trick to avoid work with THIS executable. }
  S:=DataStart;
  For I:=1 To Length(S) Do S[I]:=Chr(Not Ord(S[I]));
  If FindDataStart(Fl, S) = False Then
    Begin
      Close(Fl);
      WriteLn('Wrong executable: ' + ParamStr(1));
      Exit;
    End;
  GetMem(P, DataSize);
  O:=P;
  BlockRead(Fl, P^, DataSize);
  Close(Fl);

  S:=ParamStr(1);
  While S <> '' Do
    If ((S[Length(S)] = '.') Or (S[Length(S)] = '\')) Then Break
    Else Delete(S, Length(S), 1);
  If S = '' Then S:=ParamStr(1) + '.TXT';
  If S[Length(S)] = '\' Then S:=ParamStr(1) + '.TXT';
  If S[Length(S)] = '.' Then S:=S + 'TXT';

  Assign(Fl, S);
  ReWrite(Fl, 1);
  S:='';
  For I:=0 To DataSize-1 Do
    Begin
      If P^ <> 0 Then S:=S + Chr(Not P^)
      Else
        Begin
          If ((S = '') And (I = 3452)) Then Break; { BETA }
          { mark sections }
          For J:=0 To 8 Do
            Begin
              { Uh... Delphi allows "If S = Sections[J] Then" }
              { but TP7 work a bit incorrect with arrays. }
              K:=Copy(Sections[J], 0, 9);
              If Pos(#0, K) <> 0 Then K:=Copy(K, 1, Pos(#0, K)-1);
              If S = K Then
                Begin
                  S:='[' + S + ']';
                  Break;
                End;
            End;
          K:=S;
          S:=S + #13#10;
          BlockWrite(Fl, S[1], Length(S));
          If K = '[EOF]' Then Break; { DEMO / FULL }
          S:='';
        End;
      Inc(P);
      { TP7 long string fix... }
      J:=Length(S);
      If J = 255 Then
        Begin
          BlockWrite(Fl, S[1], J-1);
          S:=S[J]; { Not empty to avoid BETA trigger. }
        End;
    End;
  Close(Fl);
  FreeMem(O, DataSize);
  WriteLn('Done!');
End.
